<!-- Copyright 2016 The Chromium Authors. All rights reserved.
     Use of this source code is governed by a BSD-style license that can be
     found in the LICENSE file. -->

<link rel="import" href="chrome://resources/html/polymer.html">
<link rel="import" href="chrome://resources/polymer/v1_0/paper-styles/color.html">
<link rel="import" href="chrome://resources/cr_elements/shared_style_css.html">
<link rel="import" href="chrome://resources/cr_elements/cr_scrollable_behavior.html">
<link rel="import" href="chrome://resources/cr_elements/cr_lazy_render/cr_lazy_render.html">

<link rel="import" href="/components/common_styles.html">
<link rel="import" href="/components/oobe_i18n_behavior.html">

<!--
  Simple OOBE dialog which should be used for OOBE UI elements.
  It has correct size and padding. It can display top left icon, and has
  three parts: header (which should have <h1>title</h1>), footer (content part),
  and optional buttons container at the bottom.

  When shown (i.e. when outside container calls .show()):
    1. If this dialog has tags in class "focus-on-show", the first one will be
  focused.
    2. 'show-dialog' is fired.

  Please include oobe-dialog-host shared style if you use oobe-dialog.

  Example:
    <style include="oobe-dialog-host"></style>
    <oobe-dialog on-show-dialog="onTestDialogShown_" has-buttons>
      <iron-icon ... slot="oobe-icon">
      <h1 slot="title">Title</h1>
      <div slot="subtitle">Subtitle</div>
      <div slot="footer">
        <div class="focus-on-show">...</div>
        ...
      </div>
      <div slot="bottom-buttons">
        ...
      </div>
    </oobe-dialog>

  Add class |header| to all which you want to go inside the header.  Similar
  with classes |footer|, |bottom-buttons|.

  For single-DPI image |oobe-icon| class should be used. To select between two
  images of different DPI, |oobe-icon-1x| and |oobe-icon-2x| should be used
  instead. For example:

      <iron-icon icon="icon1" ... slot="oobe-icon" class="oobe-icon-1x">
      <iron-icon icon-"icon2" ... slot="oobe-icon" class="oobe-icon-2x">

  |bottom-buttons| block is shown only if |has-buttons| attribute is set.
  Please keep |bottom-buttons| block as simple as possible. Ideally just a div
  with oobe buttons. No custom styles, etc.

  Attributes:
    no-header - hides header
    no-footer-padding - disables footer padding.
    has-buttons - shows bottom buttons menu
    footer-shrinkable - whether footer should be shrunk to fit the container.
                        Most likely should be set for oobe-illustration's.
    title-key - ID of localized string to be used as default title element.
    subtitle-key - ID of localized string to be used as default subtitle
                   element.

    two-columns-adaptable - if set layout might switch to two columns instead of
        one when there is not enough vertical space for elements. Left column
        would contain header-container, right column would contain
        footerContainer. Bottom buttons are not affected. See oobe.css for
        conditions.

  I.e. [no-header no-footer-padding] will make the footer occupy all the dialog
  space.
-->
<dom-module id="oobe-dialog">
  <template>
    <!--
      TODO(https://crbug.com/1143666): Do not use oobe-dialog-host.
      Use oobe-dialog-common instead.
    -->
    <style include="oobe-dialog-host cr-shared-style">
      :host {
        --subtitle-line-height: 18px;
        @apply --oobe-default-font;
      }

      :host([two-columns-adaptable]) #topScrollContainer {
        flex-direction: var(--oobe-dialog-adaptable-flex-direction);
      }

      #topScrollContainer {
        border: transparent;
        overflow-y: auto;
      }

      #header-container {
        padding-bottom: 0;
        padding-inline-end: var(--oobe-dialog-content-padding);
        padding-inline-start: var(--oobe-dialog-content-padding);
        padding-top: var(--oobe-dialog-content-padding);
      }

      #oobe-title {
        padding-top: 20px;
      }

      /*
      * TODO(https://crbug.com/703984): remove the fallback class when fixed.
      */
      #oobe-title ::slotted(h1),
      #oobe-title .fallback {
        color: var(--oobe-header-text-color);
        @apply --oobe-header-font;
        margin: 0;
      }

      #oobe-subtitle {
        padding-top: 8px;
      }

      /*
      * TODO(https://crbug.com/703984): remove the fallback class when fixed.
      */
      #oobe-subtitle ::slotted(*),
      #oobe-subtitle .fallback {
        color: var(--oobe-subheader-text-color);
        line-height: var(--subtitle-line-height);
        overflow-wrap: break-word;
        margin: 0;
      }

      #footerContainer ::slotted(*) {
        line-height: var(--subtitle-line-height);
      }

      :host(:not([has-buttons])) #footerContainer {
        margin-bottom: 40px;
      }

      #oobe-progress ::slotted(paper-progress) {
        --paper-progress-active-color: var(--google-blue-500);
        --paper-progress-container-color: var(--google-blue-100);
        height: 3px;
        margin-top: 32px;
        width: 100%;
      }

      #footerContainer {
        padding-bottom: 0;
        padding-inline-end: var(--oobe-dialog-content-padding);
        padding-inline-start: var(--oobe-dialog-content-padding);

        /* TODO(https://crbug.com/1017173) Make it adaptive. */
        padding-top: var(--oobe-dialog-content-padding-top);
      }

      #footerContainer[noFooterPadding] {
        padding: 0;
      }

      #footerContainer[footerShrinkable] {
        flex-shrink: 1;
      }

      #topScrollContainer.can-scroll:not(.is-scrolled):not(.scrolled-to-bottom) {
        background: linear-gradient(0deg,
                                    rgba(var(--google-grey-refresh-100-rgb), 1) 0,
                                    rgba(var(--google-grey-refresh-100-rgb), 0) 8px);

      }
      #topScrollContainer.can-scroll.is-scrolled:not(.scrolled-to-bottom) {
        background: linear-gradient(0deg,
                                    rgba(var(--google-grey-refresh-100-rgb), 1) 0,
                                    rgba(var(--google-grey-refresh-100-rgb), 0) 8px),
                    linear-gradient(180deg,
                                    rgba(var(--google-grey-refresh-100-rgb), 1) 0,
                                    rgba(var(--google-grey-refresh-100-rgb), 0) 8px);
      }
      #topScrollContainer.is-scrolled.scrolled-to-bottom {
        background: linear-gradient(180deg,
                                    rgba(var(--google-grey-refresh-100-rgb), 1) 0,
                                    rgba(var(--google-grey-refresh-100-rgb), 0) 8px);
      }

      #oobe-bottom {
        height: calc(var(--oobe-dialog-footer-height)
                    - 2 * var(--oobe-dialog-footer-padding));
        /* Width: real padding - button margin */
        padding: var(--oobe-dialog-footer-padding)
                calc(var(--oobe-dialog-footer-padding) - 4px);
        z-index: 1;
      }

      #oobe-icon-div ::slotted(hd-iron-icon),
      #oobe-icon-div ::slotted(iron-icon) {
        --iron-icon-height: 32px;
        --iron-icon-width: 32px;
        --iron-icon-fill-color: var(--google-blue-600);
      }

      .slot-container {
        position: relative;
      }
    </style>
    <cr-lazy-render id="lazy">
      <template>
        <div id="topScrollContainer" class="layout vertical flex">
          <div id="header-container" hidden="[[noHeader]]">
            <div id="oobe-icon-div" class="slot-container">
              <slot name="oobe-icon"></slot>
            </div>
            <div id="oobe-title" class="slot-container layout vertical
                end-justified">
              <slot name="title">
                <h1 class="fallback">[[i18nDynamic(locale, titleKey)]]</h1>
              </slot>
            </div>
            <div id="oobe-subtitle" class="slot-container layout vertical">
              <slot name="subtitle">
                <div class="fallback">[[i18nDynamic(locale, subtitleKey)]]</div>
              </slot>
            </div>
            <div id="oobe-progress" class="slot-container layout vertical">
              <slot name="progress"></slot>
            </div>
          </div>
          <div id="footerContainer" noFooterPadding$="[[noFooterPadding]]"
              footerShrinkable$="[[footerShrinkable]]"
              class="slot-container flex-grow layout vertical">
            <slot name="footer"></slot>
          </div>
        </div>
        <template is="dom-if" if="[[hasButtons]]">
          <div id="oobe-bottom" hideShadow$="[[hideShadow]]"
              class="slot-container layout horizontal">
            <slot name="back-navigation"></slot>
            <div class="flex"></div>
            <slot name="bottom-buttons"></slot>
          </div>
        </template>
      </template>
    </cr-lazy-render>
  </template>
  <script src="oobe_dialog.js"></script>
</dom-module>

